#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_CLIENTI 100
#define MAX_FATTURE 1000

/* Struttura per memorizzare le informazioni sulle proiezioni */
typedef struct {
	int codice;
	char nome[31];
	char citta[21];
} Cliente;

/* Struttura per memorizzare le informazioni sulle sale */
typedef struct {
	int cliente;
	int numero;
	float importo;
	char stato;
} Fattura;

/* Strutture per memorizzare le informazione sui film per la biglietteria */ 
typedef struct {
	char nomecliente[31];
	float importo;
} Debito;

/* questa funzione non è richiesta, ma è comoda per rispondere alla terza
   domanda dell'esercizio. */
int leggiFatture(FILE* fatture, Fattura f[]) {
	int nfatture = 0;
	Fattura t;
	while (fscanf(fatture, "%d%d%f %c",
				  &t.cliente, &t.numero, &t.importo, &t.stato) == 4) {
		f[nfatture] = t;
		nfatture++;
	}
	return nfatture;
}

/* questa funzione non è richiesta, ma è comoda per rispondere alla terza
   domanda dell'esercizio. */
int leggiClienti(FILE* anagrafe, Cliente c[]) {
	int nclienti = 0;
	Cliente t;
	while (fscanf(anagrafe, "%d%s%s", &t.codice, t.nome, t.citta) == 3) {
	    c[nclienti] = t;
		nclienti++;
	}
	return nclienti;
}

/* procedura per leggere i dati da file */
int contaDebiti(Cliente c[], int nclienti,
				Fattura f[], int nfatture, Debito y[]) {
	int i, j;
	
	/* riempio le strutture dati con il debito totale di ciascun cliente */
	for (i = 0; i < nclienti; i++) {
		strcpy(y[i].nomecliente, c[i].nome);
		/* calcolo il debito totale */
		y[i].importo = 0;
		for (j = 0; j < nfatture; j++) {
			if (c[i].codice == f[j].cliente && f[j].stato == 'n') {
				y[i].importo += f[j].importo;
			}
		}
	}
	
	/* restituisco il numero di clienti */
	return nclienti;
}

/* programma principale */
int main() {
	/* preparo le variabili */
	Debito debitori[MAX_CLIENTI];
	Fattura fatture[MAX_FATTURE];
	Cliente clienti[MAX_CLIENTI];
	FILE *file_clienti, *file_fatture;
	int i, j, nclienti, nfatture;
	char nomecliente[31];
	int codicecliente;

	/* apro il file con i clienti */
	if ((file_clienti = fopen("anagrafe.txt", "r")) == NULL)
		exit(1);
	/* apro il file con le fatture */
	if ((file_fatture = fopen("fatture.txt", "r")) == NULL)
		exit(1);
	
	/* leggo i dati sui debiti */
	nclienti = leggiClienti(file_clienti, clienti);
	
	/* leggo i dati sulle fatture */
	nfatture = leggiFatture(file_fatture, fatture);
	
	/* chiudo i files */
	fclose(file_clienti);
	fclose(file_fatture);
	
	/* stampo il valore del debito per tutti i clienti */
	contaDebiti(clienti, nclienti, fatture, nfatture, debitori);
	printf("STATO DEI DEBITI\n");
	for (i = 0; i < nclienti; i++)
		printf("%s: %f\n", debitori[i].nomecliente, debitori[i].importo);
	
	/* chiedo il nome di un cliente */
	printf("\nInserire il nome di un cliente: ");
	scanf("%s", nomecliente);
	
	/* recupero il codice cliente */
	codicecliente = -1;
	for (i = 0; i < nclienti; i++)
		if (strcmp(clienti[i].nome, nomecliente) == 0)
			codicecliente = clienti[i].codice;
	
	/* se è stato immesso un nome di cliente valido, stampo le fatture */
	if (codicecliente >= 0) {
		for (j = 0; j < nfatture; j++)
			if (fatture[j].cliente == codicecliente && fatture[j].stato == 'n')
				printf("Fattura %d, importo: %f, non pagata\n",
					   fatture[j].numero, fatture[j].importo);
	}
}
